#include "FreeRTOS.h"
#include "task.h"

#include "STC32G_UART.h"

#include "UPS.h"
#include "comm.h"

#define CPSAddress 0x01//ƵԴģַ
#define DPSAddress 0x02//Դģַ
#define UPS_TIMEOUT_LIMIT 30//UPSͨѶʱ
#define UPS_TIMEOUT_COUNT 10//UPSͨѶʱ

//485ѡIOҪGPIO_configΪģʽ
sbit UPS_485dir = P4 ^ 7;//UPSͨѶ485ţӲ仯º˶

unsigned char UPSCMD[] = { 0x00,0x03,0x00,0x1f,0x00,0x01,0x00,0x00 };//UPS״̬ѯָ
unsigned char UPS_Timeout_Count[2];//UPSͨѶʱۼ
unsigned char UPS_State[2][2];//UPS״̬

void CopyToUart2(unsigned char *buff, unsigned char count)
{
	unsigned char i;
	for (i = 0; i < count; i++)
	{
		TX2_Buffer[COM2.TX_write] = buff[i];
		if (++COM2.TX_write >= COM_TX2_Lenth)
		{
			COM2.TX_write = 0;
		}
	}
}

portTASK_FUNCTION(vUPSTask, pvParameters)
{
	unsigned int crc16;
	unsigned char timeout_limit;

	UNUSED(pvParameters);	
	UPSCMD[0] = CPSAddress;//ʼӿƵԴģ鿪ʼѯ
	while (1)
	{		
		UPS_485dir = 1;//485ͨѶߣΪ״̬
		crc16 = MODBUS_CRC16(UPSCMD, 6);//crc16У
		UPSCMD[6] = (unsigned char)crc16;
		UPSCMD[7] = (unsigned char)(crc16 >> 8);
		CopyToUart2(UPSCMD, 8);//ͨ2UPSͨѶ
		if (!COM2.B_TX_busy)//2ʹڿ״̬
		{
			COM2.B_TX_busy = 1;//Ǵ2ڷ״̬
			S2TI = 1;//2жϣݷ
		}
		while (COM2.B_TX_busy)//ȴ2ݷ
		{
			taskYIELD();//ʣʱ䣬лͬȼľ
		}
		vTaskDelay(1);//ʱ1msȷһλϣʱ벨й
		UPS_485dir = 0;//485ͨѶͣΪ״̬
		timeout_limit = UPS_TIMEOUT_LIMIT;//õͨѶʱ
		while (timeout_limit--)//ȴUPSϢͨѶʱ˳ȴ
		{
			if (COM2.RX_TimeOut > 0)//
			{
				if (--COM2.RX_TimeOut == 0)//ݽ
				{
					if (COM2.RX_Cnt > 3)//ݰݺУ
					{
						crc16 = MODBUS_CRC16(RX2_Buffer, COM2.RX_Cnt - 2);//㷴ϢУ
						if ((RX2_Buffer[COM2.RX_Cnt - 2] == (unsigned char)crc16) && (RX2_Buffer[COM2.RX_Cnt - 1] == (unsigned char)(crc16 >> 8)))//ȷ
						{
							UPS_State[UPSCMD[0] - 1][0] = RX2_Buffer[3];//UPS״̬
							UPS_State[UPSCMD[0] - 1][1] = RX2_Buffer[4];//UPS״̬
							UPS_Timeout_Count[UPSCMD[0] - 1] = 0;//״̬Ѹ£㳬ʱۼ
						}
						else//У
						{
							timeout_limit = 0;//ϢȴͬͨѶʱ
						}
					}
					COM2.RX_Cnt = 0;//´νݴӴ2ջʼλÿʼ
					break;//˳ѭٵȴ
				}
			}
			vTaskDelay(1);//ʱ1ms
		}
		if (timeout_limit == 0)//ͨѶʱͨѶϢ
		{
			UPS_Timeout_Count[UPSCMD[0] - 1]++;//ʱ
		}
		if (UPSCMD[0] == CPSAddress)//лƵԴԴѯ
		{
			UPSCMD[0] = DPSAddress;
		}
		else
		{
			UPSCMD[0] = CPSAddress;
		}
	}
}